//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3FBBE7C70282.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3FBBE7C70282.cm

//## begin module%3FBBE7C70282.cp preserve=no
//## end module%3FBBE7C70282.cp

//## Module: ClusterRegion%3FBBE7C70282; Package body
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Model/MixFunction/ClusterRegion.cxx

//## begin module%3FBBE7C70282.additionalIncludes preserve=no
//## end module%3FBBE7C70282.additionalIncludes

//## begin module%3FBBE7C70282.includes preserve=yes
#include <CCfits/CCfits>
#include <CCfits/FITSBase.h>
//## end module%3FBBE7C70282.includes

// ClusterRegion
#include "ClusterRegion.h"
//## begin module%3FBBE7C70282.declarations preserve=no
//## end module%3FBBE7C70282.declarations

//## begin module%3FBBE7C70282.additionalDeclarations preserve=yes
//## end module%3FBBE7C70282.additionalDeclarations


// Class ClusterRegion::ClusterRegionError 

ClusterRegion::ClusterRegionError::ClusterRegionError (const string& msg)
  //## begin ClusterRegion::ClusterRegionError::ClusterRegionError%3FBCEA890200.hasinit preserve=yes
  : YellowAlert("Cluster region error: ")
  //## end ClusterRegion::ClusterRegionError::ClusterRegionError%3FBCEA890200.hasinit
  //## begin ClusterRegion::ClusterRegionError::ClusterRegionError%3FBCEA890200.initialization preserve=yes
  //## end ClusterRegion::ClusterRegionError::ClusterRegionError%3FBCEA890200.initialization
{
  //## begin ClusterRegion::ClusterRegionError::ClusterRegionError%3FBCEA890200.body preserve=yes
  std::cerr << msg << std::endl;
  //## end ClusterRegion::ClusterRegionError::ClusterRegionError%3FBCEA890200.body
}


// Class ClusterRegion 

//## begin ClusterRegion::instrumentNames%3FBCF155013A.attr preserve=no  public: static std::vector<std::string> {U} 
std::vector<std::string> ClusterRegion::s_instrumentNames;
//## end ClusterRegion::instrumentNames%3FBCF155013A.attr

//## begin ClusterRegion::NINST%3FCBC5D20032.attr preserve=no  public: static size_t {UC} 4
const size_t ClusterRegion::s_NINST = 4;
//## end ClusterRegion::NINST%3FCBC5D20032.attr

//## begin ClusterRegion::instMapSizes%4034D9410187.attr preserve=no  public: static IntegerArray {V} 
IntegerArray ClusterRegion::s_instMapSizes;
//## end ClusterRegion::instMapSizes%4034D9410187.attr

ClusterRegion::ClusterRegion (const string& fileName, int regionNumber, size_t spectrumNumber)
  //## begin ClusterRegion::ClusterRegion%3FBBE8A5016A.hasinit preserve=yes
  : WmapRegion(),
    m_optic(std::pair<Real,Real>(.0,.0)),
    m_instrument(0),
    m_center(std::pair<Real,Real>(.0,.0)),
    m_nPixInRegion(0),
    m_regionNumber(regionNumber),
    m_spectrumNumber(spectrumNumber),
    m_instMapFractions()
  //## end ClusterRegion::ClusterRegion%3FBBE8A5016A.hasinit
  //## begin ClusterRegion::ClusterRegion%3FBBE8A5016A.initialization preserve=yes
  //## end ClusterRegion::ClusterRegion%3FBBE8A5016A.initialization
{
  //## begin ClusterRegion::ClusterRegion%3FBBE8A5016A.body preserve=yes
  if (s_instrumentNames.empty())
  {
     s_instrumentNames.push_back("SIS0");
     s_instrumentNames.push_back("SIS1");
     s_instrumentNames.push_back("GIS2");
     s_instrumentNames.push_back("GIS3");
  }
  if (s_instMapSizes.empty())
  {
     s_instMapSizes.push_back(40);
     s_instMapSizes.push_back(40);
     s_instMapSizes.push_back(64);
     s_instMapSizes.push_back(64);
  }
  if (s_instrumentNames.size() != s_NINST || s_instMapSizes.size() != s_NINST)
  {
     throw RedAlert("ClusterRegion: Intstrument names/sizes array size mismatch");
  }
  int nullVal = -1;
  read(fileName, &nullVal);
  calcInstMapFractions();
  //## end ClusterRegion::ClusterRegion%3FBBE8A5016A.body
}


ClusterRegion::~ClusterRegion()
{
  //## begin ClusterRegion::~ClusterRegion%3FBBE82101BD_dest.body preserve=yes
  //## end ClusterRegion::~ClusterRegion%3FBBE82101BD_dest.body
}



//## Other Operations (implementation)
void ClusterRegion::readSpecificKeys ()
{
  //## begin ClusterRegion::readSpecificKeys%3FBCCB7802B1.body preserve=yes
  const CCfits::PHDU& hdu = file()->pHDU();
  string errorKey("INSTRUME");
  try
  {
     string instrument;
     hdu.keyWord("INSTRUME").value(instrument);
     convertNameToInt(instrument);
     errorKey = "OPTIC1";
     float tmpFloat = .0;
     hdu.keyWord(errorKey).value(tmpFloat);
     m_optic.first = static_cast<Real>(tmpFloat);
     m_optic.first /= 4.0;
     errorKey = "OPTIC2";
     hdu.keyWord(errorKey).value(tmpFloat);
     m_optic.second = static_cast<Real>(tmpFloat);
     m_optic.second /= 4.0;
  }
  catch (CCfits::FitsException&)
  {
     string msg = "Error reading ";
     msg += errorKey;
     msg += " keyword(s) in ";
     msg += hdu.parent()->name();
     throw ClusterRegionError(msg);
  }
  
  //## end ClusterRegion::readSpecificKeys%3FBCCB7802B1.body
}

void ClusterRegion::convertNameToInt (const string& instrument)
{
  //## begin ClusterRegion::convertNameToInt%3FBCEF4103A8.body preserve=yes
  int i = 0;
  int sz = s_instrumentNames.size();  
  while (i < sz)
  {
     if (instrument == s_instrumentNames[i])  break;
     ++i;   
  }
  if (i < sz)
  {
     m_instrument = i;
  }
  else
  {
     string msg = "Unrecognized instrument name in file ";
     msg += file()->pHDU().parent()->name();
     throw ClusterRegionError(msg);
  }
  //## end ClusterRegion::convertNameToInt%3FBCEF4103A8.body
}

void ClusterRegion::calcInstMapFractions ()
{
  //## begin ClusterRegion::calcInstMapFractions%4034DAF801CE.body preserve=yes
  int nInst = s_instMapSizes[m_instrument];
  int nxpix = nx();
  int nypix = ny();
  Real xmap = lowerLeft().first;
  Real ymap = lowerLeft().second;
  const std::valarray<bool>& isWmapOn = isPixOn();
  if (version() >= 2.0)
  {
     xmap += (wmrbn()-1.0)/2.0;
     xmap /= wmrbn();
     ymap += (wmrbn()-1.0)/2.0;
     ymap /= wmrbn();
  }
  m_instMapFractions.resize(nInst*nInst, .0);
  for (int iy=0; iy<nInst; ++iy)
  {
     int iyOffset = iy*nInst;
     for (int ix=0; ix<nInst; ++ix)
     {
        int iFrac = iyOffset + ix;
        // ixpos and iypos below are 1-based as in the original
        // fortran code.  This results in m_center also being 
        // 1-based.
        for (int jy=0; jy<4; ++jy)
        {
           // truncation of Real values is intentional
           int iypos = static_cast<int>(jy+1 + iy*4 - ymap + 1);
           if (iypos >= 1 && iypos <= nypix)
           {
              for (int jx=0; jx<4; ++jx)
              {
                 int ixpos = static_cast<int>(jx+1 + ix*4 - xmap + 1);
                 if (ixpos >= 1 && ixpos <= nxpix)
                 {
                    if (isWmapOn[nxpix*(iypos-1)+ixpos-1])
                    {
                       m_instMapFractions[iFrac] += 1./16.;
                       m_center.first += ixpos + xmap - 1.;
                       m_center.second += iypos + ymap - 1.;
                       ++m_nPixInRegion;
                    }
                 }
              }
           }
        }
     }
  }
  if (m_nPixInRegion)
  {
     m_center.first /= m_nPixInRegion;
     m_center.second /= m_nPixInRegion;
  }
  //## end ClusterRegion::calcInstMapFractions%4034DAF801CE.body
}

// Additional Declarations
  //## begin ClusterRegion%3FBBE82101BD.declarations preserve=yes
  //## end ClusterRegion%3FBBE82101BD.declarations

//## begin module%3FBBE7C70282.epilog preserve=yes
//## end module%3FBBE7C70282.epilog
